
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spring 2.0中新的Bean类型实现原理 / iVAN</title>

    <meta name="description" content="Spring 2.0中新的Bean类型实现原理 我们知道,在Spring2.0中,除了singleton及prototype两种类型的Bean以外.默认情况下还增加了request.session及global session三种类型的Bean,增加的三种类型的Bean主要应用于Web应用程序中.本文不打算分析三种类型的Bean的用法,只是简单分析框架的实现原理. Spring2.0中新增了一个用来表示Bean范围的Scope接口 public interface Scope { Object get(String name, ObjectF">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Spring 2.0中新的Bean类型实现原理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>我们知道，在Spring2.0中，除了singleton及prototype两种类型的Bean以外。默认情况下还增加了request、session及global session三种类型的Bean，增加的三种类型的Bean主要应用于Web应用程序中。本文不打算分析三种类型的Bean的用法，只是简单分析框架的实现原理。</p>
<p>Spring2.0中新增了一个用来表示Bean范围的Scope接口</p>
<p><code>public interface Scope {<br />
　Object get(String name, ObjectFactory objectFactory);//根据名称及创建工厂得到一个Bean实例<br />
　Object remove(String name);//删除一个指定名称的Bean<br />
}</code></p>
<p>在容器ConfigurableBeanFactory接口中定义了Bean工厂有关Scope注册的相关方法，使得可往Bean工厂中加入新类型的Bean。</p>
<p><code>public interface ConfigurableBeanFactory extends HierarchicalBeanFactory,<br />
　void registerScope(String scopeName, Scope scope);//往Bean工厂中添加一个新的范围(默认只有两种范围： 　singleton及prototype)<br />
　void destroyScopedBean(String beanName);//销毁B ean工厂中范围Bean<br />
}</code></p>
<p>在AbstractFactoryBean的getBean方法中实现了对特定Scope Bean支持，核心代码摘要：</p>
<p><code>String scopeName = mergedBeanDefinition.getScope();<br />
　//取得当前Bean的范围，也即在定义中的scope=”request”的部分。<br />
　Scope scope = (Scope) this.scopes.get(scopeName);//得到Bean工厂中的范围处理器<br />
　if (scope == null) {<br />
　　throw new IllegalStateException("No Scope registered for scope '" + scopeName + "'");<br />
　}<br />
　try {<br />
　　//使用scope.get(beanName,ObjectFactory)从指定的范围中得到或创建Bean实例<br />
　　Object scopedInstance = scope.get(beanName, new ObjectFactory() {<br />
　　　public Object getObject() throws BeansException {<br />
　　　　beforePrototypeCreation(beanName);//前拦截<br />
　　　　try {<br />
　　　　　return createBean(beanName, mergedBeanDefinition, args);<br />
　　　　　//调用子类的createBean实现真正的Bean创建工作<br />
　　　　}<br />
　　　　finally {<br />
　　　　　afterPrototypeCreation(beanName);//后拦截<br />
　　　　}<br />
　　　}<br />
　　});<br />
　　bean = getObjectForBeanInstance(scopedInstance, name, mergedBeanDefinition);//返回正确类型的Bean实例<br />
　}<br />
　catch (IllegalStateException ex) {<br />
　　throw new BeanCreationException(beanName, "Scope '" + scopeName + "' is not active", ex);<br />
　}</code></p>
<p>默认情况下，低层的Bean工厂中只支持singleton及prototype两种类型的Bean。当把scope设置成request及session时将会出现不能正确识别Scope的错误。这是因为普通的Bean工厂都没有注册新的Scope。只有在WebApplicationContext中注册才注册了新类型的Bean。</p>
<p>下面看实现注册Scope的代码:</p>
<p>在WebApplicationContext中定义常量</p>
<p><code>public interface WebApplicationContext extends ApplicationContext {<br />
　String SCOPE_REQUEST = "request";<br />
　String SCOPE_SESSION = "session";<br />
　String SCOPE_GLOBAL_SESSION = "globalSession";<br />
}</code></p>
<p>然后在所有类型的Web应用上下文的实现中，都在Bean工厂的拦载过程中通过postProcessBeanFactory方法来注册新类型Scope，如GenericWebApplicationContext、StaticWebApplicationContext、AbstractRefreshableWebApplicationContext等WebApplication应用上下文实现中。</p>
<p><code>protected void postProcessBeanFactory(ConfigurableListableBeanFactory beanFactory) {<br />
　beanFactory.registerScope(SCOPE_REQUEST, new RequestScope());//注册request类型的Bean<br />
　beanFactory.registerScope(SCOPE_SESSION, new SessionScope(false));//注册session类型的Bean<br />
　beanFactory.registerScope(SCOPE_GLOBAL_SESSION, new SessionScope(true));//注册glogalsession的Bean<br />
}</code></p>
<p>结合上面的代码，现在应该明白为什么只有在Web应用上下文中才能使用新增加三种类型的Bean了吧。当然，由于有了Scope，我们也可以非常轻松的实现我们自己的Scope，增加新用户自定义类型的Bean，然后设计出一个适合我们自己的Bean工厂。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 06:00:45</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b3%a8%e5%86%8c/" title="注册">注册</a>, <a href="https://www.iamivan.net/tag/%e7%b1%bb%e5%9e%8b/" title="类型">类型</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/%e5%b7%a5%e5%8e%82/" title="工厂">工厂</a>, <a href="https://www.iamivan.net/tag/bean/" title="bean">bean</a>, <a href="https://www.iamivan.net/tag/scope/" title="scope">scope</a>, <a href="https://www.iamivan.net/tag/%e6%b3%a8%e5%86%8c%e5%b7%a5%e5%8e%82/" title="注册工厂">注册工厂</a>, <a href="https://www.iamivan.net/tag/spring%e7%9a%84%e5%ae%9e%e7%8e%b0%e5%8e%9f%e7%90%86/" title="spring的实现原理">spring的实现原理</a>, <a href="https://www.iamivan.net/tag/scope%e5%ae%9e%e4%be%8b/" title="Scope实例">Scope实例</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Spring 2.0中新的Bean类型实现原理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zedZOp.html" rel="bookmark">Spring2&period;0中新的Bean类型实现原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们知道,在Spring2.0中,除了singleton及prototype两种类型的Bean以外.默认情况下还增加了request.session及global session三种类型的Bean,增加的三种类型的Bean主要应用于Web应用程序中.本文不打算分析三种类型的Bean的用法,只是简单分析框架的实现原理. Spring2.0中新增了一个用来表示Bean范围的Scope接口 public interface Scope { Object get(String name, ObjectF			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm3NeBb.html" rel="bookmark">C＃7&period;0中新特性汇总&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下将是 C# 7.0 中所有计划的语言特性的描述.随着 Visual Studio &quot;15&quot; Preview 4 版本的发布,这些特性中的大部分将活跃起来.现在是时候来展示这些特性,你也告诉借此告诉我们你的想法! C#7.0 增加了许多新功能,并专注于数据消费,简化代码和性能的改善.或许最大的特性就是元祖和模式匹配,元祖可以很容易地拥有多个返回结果,而模型匹配可以根据数据的&quot;形&quot;的不同来简化代码.我们希望,将它们结合起来,从而使你的代码更加简洁高效,也可以使你更加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj79x0M.html" rel="bookmark">在Spring 2&period;0中集成AspectJ</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Java语言中,从织入切面的方式上来看,存在三种织入方式:编译期织入.类加载期织入和运行期织入.编译期织入是指在Java编译期,采用特殊的编译器,将切面织入到Java类中:而类加载期织入则指通过特殊的类加载器,在类字节码加载到JVM时,织入切面:运行期织入则是采用CGLib工具或JDK动态代理进行切面的织入. AspectJ采用编译期织入和类加载期织入的方式织入切面,是语言级的AOP实现,提供了完备的AOP支持.它用AspectJ语言定义切面,在编译期或类加载期将切面织入到Java类中. 在低			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGeJEM.html" rel="bookmark">C&num; 3&period;0中新匿名类型特性初体验</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在去年PDC2005上,在发布C#2.0 (C# Whidbey)的同时,微软也同时展示了它们在C# 3.0上的一些计划.在提到一系列新的语言特性如语言集成查询(LINQ)等,Redmond同时也介绍了一个新的特性--匿名类型.本文详细介绍了匿名类型. 匿名类型定义 C#3.0规范将匿名类型描述为从对象初始化器(object initializer)自动推断和生成的元组类型.在你能够充分领会这一定义之前,你需要了解&quot;对象初始化器&quot;的概念,它是匿名类型特性的基础. 对象初始化器给一个对象			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Myr9AZp.html" rel="bookmark">Spring 2&period;0的新特性点评</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spring2.0的发布恐怕算得上2006年Java社区的一件大事了.在Spring2.0发布附带的文档里面对2.0新特性做了概要的介绍,2.0的新特性是自然是我们最关注的方面: 一.Spring的XML配置引入XML Schema语法简化配置 在Spring1.x系列中,bean的配置文件使用DTD,没有namespace的分隔.2.0的一个非常大的改进是引入了XML Schema的namespace,因而可以将bean的配置文件做大幅度的简化.这些简化包括了对bean属性的各种简化,AOP配			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/lpP84Dp.html" rel="bookmark">Jsdk5&period;0中新增枚举enum类型使用例解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js 作者:Junsan Jin 日期:2005-03-25 邮箱:junsan21@126.com ; junnef21@sohu.com Jsdk5.0中新增了很多的特性,如泛型.增强的循环.改进的装.拆箱.静态引入等,大大增强了java语言的易用性. 我现在正在做一个从com+(dcom)平台到j2ee平台移植的项目,中间有很多枚举类型的定义,以前做起来要引入第三方类库,或者自己写类库,或者干脆定义成静态变量使用,很不方便,而且可能会产生很多问题.Jsdk5.0的发布正好解决了这些问题.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zeXJVp.html" rel="bookmark">&period;net 2&period;0中新增的nullable类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				.net 2.0中,有新增的nullable类型,主要可以用为基本的值类型赋予null的值,比如 int? k = 3;//一个可为空的值类型(简称空类型)int m = null;//错误int? j = null;//成功从上面的例子我们可以看到在值类型后可以定义一个可为空的值类型,在C#中,是在基本类型后加一个?号,而在VB.NET中,可以这样 Dim dtmVarName As Nullable(Of DateTime) Dim intVarName As Nullable(Of Int			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj7lQNM.html" rel="bookmark">WF4&period;0中四种自定义类型活动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				工作流中的活动就像用户自定义的控件,将许多的功能封装起来用.WF4.0中提供了四种可继承的活动 类:CodeActivity .AsyncCodeActivity.Activity.NativeActivity.这几种活动都有自己使用的适合 场合,正确的使用这些活动将非常有利. 1.CodeActivity WF4.0中的活动是树形结构的,创建叶子活动最简单是方式就是使用CodeActivity ,它的逻辑都放在 一个方法:Execute 里面,这个也是四种活动中最简单的一种.这里用一个简单的自			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMNrN7M.html" rel="bookmark">C&num; 2&period;0 中Iterators的改进与实现原理浅析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C#语言从VB中吸取了一个非常实用的foreach语句.对所有支持IEnumerable接口的类的实例,foreach语句使用统一的接口遍历其子项,使得以前冗长的for循环中繁琐的薄记工作完全由编译器自动完成.支持IEnumerable接口的类通常用一个内嵌类实现IEnumerator接口,并通过IEnumerable.GetEnumerator函数,允许类的使用者如foreach语句完成遍历工作. 这一特性使用起来非常方便,但需要付出一定的代价.Juval Lowy发表在MSDN杂志2004年			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd6R4b.html" rel="bookmark" class="title">一个twitter puddles的算法实现</a>
					<div>
						今天发现了一个挺好玩的算法题,下面是它的算法描述,源自twitter的一道面试题 twitter puddles 算法描述 数字是根据一个数组内容来描述的,最后会根据每个数字的大小来模拟一道墙的高度, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkGd1p.html" rel="bookmark" class="title">杂乱图片统一管 Windows 7多媒体中心的妙用</a>
					<div>
						&quot;媒体中心&quot;是Win7家庭高级版或以上版本具备的一项功能,它经常被大家与 Windows Media Player混淆,认为它就是一个播放器,是用来播放音频和视频文 件的.其实wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwaO8z.html" rel="bookmark" class="title">如何限制sa登录Sybase ASE</a>
					<div>
						解决思路如下: 利用sybase ASE的特性提供的存储过程 sp_modifylogin,对登录的合法性进行验证. 先新创建一个权限足够高的用户,将来当服务器有问题时,好用来恢复sa 接下来将sa的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVndq4z.html" rel="bookmark" class="title">联想大胆尝试更改ThinkPad键盘设计</a>
					<div>
						[新浪科技讯]北京时间6月29日晚间消息,据国外媒体报道,联想本周公布了历时一年研究的两项针对ThinkPad笔记本电脑的设计,将&quot;Delete&quot;和&quot;Escape&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrK52xp.html" rel="bookmark" class="title">Struts2类型转换&lpar;一&rpar; 常规类型&comma;自定义类型&comma;错误处理</a>
					<div>
						Struts2的类型转换是基于OGNL表达式的.有良好的扩展性. WEB应用接收到表单提交的数据都 是String类型的,Struts2可方便的转换为 常规类型(数值,日期)/ 自定义类型(User, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEl2k3z.html" rel="bookmark" class="title">PS人像皮肤美白磨皮教程</a>
					<div>
						        PS人像皮肤美白磨皮 PS网页设计教程 PS特效制作教程 PS海报设计教程 分类: PS图片处理 ps磨皮教程 ps美白教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxjoob.html" rel="bookmark" class="title">加快宽带上网速度的技巧</a>
					<div>
						   如果您所用的局域网网络特别不好,或是使用宽频方式上网,那么在注册表中设定适当的TcpWindow值,就可以加快上网速度.(请朋友们注意:如网速正常的效果不明显)计算机       打开注册表编辑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKYYWp.html" rel="bookmark" class="title">CSS样式表教程&colon;screen媒体类型的作用</a>
					<div>
						  CSS @media 规则非常适合于将 HTML 或 XML 文档定位为目标输出方法.目前, print 媒体的使用非常普遍,与实现单独的 &quot;可打印版本&quot; 相比, print  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY26PBp.html" rel="bookmark" class="title">五笔中键名汉字的输入方法</a>
					<div>
						  我们之前介绍了一级简码.二级简码和三级简码的相关知识,如果4下都是按的同一简码呢?这类汉字我们称之为键名汉字.下面,我就详细的跟大家介绍一下键名汉字的输入规则和方法,大家感受一下. 什么是键名汉字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr6V4p.html" rel="bookmark" class="title">教你创建美味可口的果冻豆文字效果</a>
					<div>
						  先看效果图: 1.创建一个500*500的画布. 2.用椭圆工具创建一个圆,大小自己定,随意. 3.用直接选择工具框选中中间的锚点. 4.用方向键的左箭头键进行移动. 5.用直接选择工具移动锚点的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EYAvM.html" rel="bookmark" class="title">Photoshop三步子制作锐化效果的猫咪毛发</a>
					<div>
						在拍摄小动物时,很难拍摄到它们清晰的毛发效果,此时就可以通过后期处理,还原清晰的毛发.利用Camera Raw中的&quot;锐化&quot;选项对图像进行锐化处理,使模糊的图像变得清晰,并结合颜色的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3gnvp.html" rel="bookmark" class="title">怎样设置开机启动项</a>
					<div>
						很多网友不知道开机启动项怎么设置,担心不小心设置错了导致电脑开不了机或者出现其他的程序不能启动的问题.今天小编就来教大家怎样合理安全的设置开机启动项,将开机需要加载的程序减少到最小,并保证所有程序能够 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8v6vp.html" rel="bookmark" class="title">怎样在Windows XP中运行DOS程序方法</a>
					<div>
						  在WindowsXP的命令提示符中输入:start /seperate要运行的程序,即可运行相应的DOS程序.其中参数separate的作用是在单独的内存空间启动16位程序,而用参数shared则 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjAlLb.html" rel="bookmark" class="title">u盘空文件夹无法删除怎么办</a>
					<div>
						  1.把u盘插入电脑的usb接口处,依次打开&quot;我的电脑 - U盘盘符 - 右键选择&quot;属性&quot;-&quot;工具&quot;选项卡 &quot;,如下图所示: 2.接着点击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY2BOM.html" rel="bookmark" class="title">开发者论坛一周精粹&lpar;第十一期&rpar;：阿里怎么发工资？自研薪酬管理系统首次曝光</a>
					<div>
						第十一期(2017年6月17日-2017年6月23日 ) 人力资源管理系统是用集中的数据将几乎所有的人力资源相关的信息(组织.招聘.薪资.绩效.审批等)统一管理起来,是企业运行必不可少的管理软件.国际 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7JOjM.html" rel="bookmark" class="title">PostgreSQL pgbench SQL RT 与 事务RT 浅析</a>
					<div>
						背景 使用pgbench测试数据库性能时,在输出的报告中,可以输出事务的平均RT,以及单条SQL的平均RT. 那么这两个有什么分别呢? 每行代表一个线程,被填充了颜色的部分表示从客户端发起SQL到SQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA8xaM.html" rel="bookmark" class="title">服务器-webservice&comma;serviceClient&period;invokeBlocking</a>
					<div>
						问题描述 webservice,serviceClient.invokeBlocking serviceClient.invokeBlocking(qname, parameters)这个方法是不是已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3Ol5z.html" rel="bookmark" class="title">基于阿里的Node全栈之路（一）部署Docker</a>
					<div>
						在经历多次项目技术改革,现在的技术架构基本稳定下来了.一个人的开发不容易啊,想在这里分享下自己的一些想法和走过的一些坑,希望能够帮助到大家.下面放下我现在的技术架构. Docker是个好东西,虽然阿里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NdKXM.html" rel="bookmark" class="title">如果将256&ast;256的图像进行小波变换分解得到的低频系数和高频系数都是多大的矩阵？？？</a>
					<div>
						问题描述 如果将256*256的图像进行小波变换分解得到的低频系数和高频系数都是多大的矩阵??? matlab中实现的 如果将256*256的图像进行小波变换分解得到的低频系数和高频系数都是多大的矩阵 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NL9qM.html" rel="bookmark" class="title">支付宝为何延迟了收益</a>
					<div>
						有天早上,http://www.aliyun.com/zixun/aggregation/1434.html&quot;&gt;支付宝钱包的&quot;余额宝&quot;收益一栏中赫然显示着&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3738z.html" rel="bookmark" class="title">编程-修改了下代码就运行出错了，怎么回事？</a>
					<div>
						问题描述 修改了下代码就运行出错了,怎么回事? #include&lt;iostream&gt; using namespace std; struct list { int data; struct ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQandp.html" rel="bookmark" class="title">extjs-Extjs5&period;1 datefield透明</a>
					<div>
						问题描述 Extjs5.1 datefield透明 我用Sencha cmd创建了一个app,但是为什么它的日历控件的背景变透明了? 解决方案 我官网下载的5.1没问题,是不是你的样式被修改过了 你可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKr2jb.html" rel="bookmark" class="title">ubuntu下面的apache2用JK模式整合tomcat后tomcat的Jsp显示404找不到</a>
					<div>
						问题描述 ubuntu下面的apache2用JK模式整合tomcat后tomcat的Jsp显示404找不到 我是使用Jk的连接方式修改了几个文件 1. /etc/libapache2-mod-jk/w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z0k6z.html" rel="bookmark" class="title">个人站点阶段性分析   做站经验分享</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在今天我对自己做站一个很大的分析, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXnXWz.html" rel="bookmark" class="title">oracle备份恢复参考日志&mdash;&mdash;实例恢复</a>
					<div>
						http://blog.csdn.net/robinson_0612/article/details/5768233 一.Oracle实例失败     Oracle实例失败多为实例非一致性关闭所致,通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB18naz.html" rel="bookmark" class="title">firefox-火狐兼容性问题，如何实现点击按钮弹出一个saveAs</a>
					<div>
						问题描述 火狐兼容性问题,如何实现点击按钮弹出一个saveAs 在IE下可以用document.execCommand(&quot;saveas&quot;,false,&quot;t.txt&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JoEAz.html" rel="bookmark" class="title">【java集合系列】--- LinkedList</a>
					<div>
						开篇前言--LinkedList中的基本用法 在前面的博文中,小编介绍List接口中的ArrayList集合,List这个接口,有两个实现类,一个就是ArrayList另一个是LinkedList(链 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLx3VM.html" rel="bookmark" class="title">python精简笔记&lpar;四&rpar;&mdash;&mdash;高阶函数</a>
					<div>
						以Python内置的求绝对值的函数abs()为例 &gt;&gt;&gt; f = abs &gt;&gt;&gt; f(-10) 10 变量f现在已经指向了abs函数本身.直接调用abs()函数和调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xgJXb.html" rel="bookmark" class="title">PostgreSQL FOR 快递公司快件跟踪表设计思考</a>
					<div>
						快递随着电商的崛起逐渐火爆, 特别是电商搞大促销的阶段, 快递更是达到爆仓的状态. 如果全国电商1天生成100亿比交易的话, 快递公司的IT是怎么完成这些无纸化操作的呢, 比如数据录入, 快件的状态跟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRN2RGM.html" rel="bookmark" class="title">linux下内存调试工具&mdash;&mdash;valgrind</a>
					<div>
						1.valgrind之memcheck  最常用的工具,用来检测程序中出现的内存问题,所有对内存的读写都会被检测到,一切对malloc()/free()/new/delete的调用都会被捕获.所以,它 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
